function Method_Of_Adjustment
%
%2015/07/06 Hisakata made
%2015/07/13 Hisakata update

AssertOpenGL;

try   
    fname = sprintf('Experiment.mat');
    
    KbName('UnifyKeyNames');
    
    %=======Make a stracture========
    Condition = [1 2 3];
    Name_of_Condition = {'Cond1' 'Cond2' 'Cond3'};
    Number_of_Condition = length(Condition);
    Number_of_Repeart = 10;
    Min_stimulus = -1;
    Max_stimulus = 1;
    StepSize = 0.01;
    
    [Data,Randam_Order_Condition,Randam_Order_trial,Total_Number_of_Trial] =...
        MakeDataFile_Adjustment(Number_of_Repeart,Number_of_Condition,Name_of_Condition);
    
    Data_raw = zeros(Total_Number_of_Trial,4)-999;
    %==================================
    
    
%========= Begin the Experiment ===========================================
HideCursor;

for ii = 1:Total_Number_of_Trial

    Current_Condition = Randam_Order_Condition(ii);
    Current_trial = Randam_Order_trial(ii);

    Stimulus = rand(1)*(abs(Max_stimulus)+abs(Min_stimulus))-abs(Min_stimulus);

    if Current_Condition == 1

        Onset_time = GetSecs;
        while 1
            %~~~~ Presentation ~~~~~~~~~~~~~~~~~~
            disp(Stimulus)
            %~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

            %~~~~ Get the answer ~~~~~~~~~~~~~~~~~~~~~
            [keyIsDown, secs, keyCode] = KbCheck;
            if keyIsDown
                if strcmp(KbName(keyCode),'f')
                    Stimulus = Stimulus - StepSize;
                    if Stimulus < Min_stimulus
                        Stimulus = Min_stimulus;
                    end
                elseif strcmp(KbName(keyCode),'j')
                    Stimulus = Stimulus + StepSize;
                    if Stimulus > Max_stimulus
                        Stimulus = Max_stimulus;
                    end
                elseif strcmp(KbName(keyCode),'space')

                    break
                end
            end
            %~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        end

        %Calculate the reaction time
        Offset_time = GetSecs;
        ReactionTime = Offset_time - Onset_time;

    elseif Current_Condition == 2
        ...
    elseif Current_Condition == 3
    ...
    end


%~1) Put the answer into the matrix
Data_raw(ii,1) = ii;
Data_raw(ii,2) = Current_Condition;
Data_raw(ii,3) = Stimulus;
Data_raw(ii,4) = ReactionTime;

%~2) Put the answer into the stracture
Data(Current_Condition).AnswerSheet(Current_trial) = Stimulus;
Data(Current_Condition).ReactionTime(Current_trial) = ReactionTime;

WaitSecs(0.3);
end
%===============End the Experiment=========================================

save(fname,'Data_raw','Data');
ShowCursor;
Screen('CloseAll');

catch ME
    ShowCursor;
    Screen('CloseAll');
    rethrow(ME);
end;

%% local function
function [Data,Randam_Order_Condition,Randam_Order_trial,Total_Number_of_Trial] =...
    MakeDataFile_Adjustment(Number_of_Repeart,Number_of_Condition,Name_of_Condition)

Answer_Sheet = zeros(1,Number_of_Repeart)-999;
Reaction_Time = zeros(1,Number_of_Repeart)-999;

for i = 1:Number_of_Condition
    Data(i).Condition = Name_of_Condition(i);   
    Data(i).AnswerSheet = Answer_Sheet;         
    Data(i).ReactionTime = Reaction_Time;       
end

Total_Number_of_Trial = Number_of_Condition*Number_of_Repeart;

Randam_condition_Number = randperm(Total_Number_of_Trial);

Randam_Order_Condition = floor((Randam_condition_Number-1)/Number_of_Repeart)+1;
Randam_Order_trial = mod((Randam_condition_Number-1),Number_of_Repeart)+1;
