function Methods_Of_ConstantStimuli
%
%2015/07/06 Hisakata made
%2015/07/13 Hisakata update

AssertOpenGL;

try
    fname = sprintf('Experiment.mat');
    
    %======= Make data set ========
    Condition = [1 2 3];
    Name_of_Condition = {'Cond1' 'Cond2' 'Cond3'};
    Stimulus = [1 2 3 4 5];
    Number_of_Repeart = 10;
    
    [Data,Total_Number_of_Trial,Condition_Number,Row_Number,Column_Number] =...
        ConstantStimuli(Condition,Stimulus,Number_of_Repeart,Name_of_Condition);
    Data_raw = zeros(Total_Number_of_Trial,5)-999;
    %==============================
    
    
%========= Begin the Experiment ===========================================
HideCursor;

for ii = 1:Total_Number_of_Trial

    Current_RowNumber = Row_Number(ii);
    Current_ColumnNumber = Column_Number(ii);
    Current_Condition = Condition_Number(ii);
    Current_Stimulus = Stimulus(Current_RowNumber);

    %~~~~ Presentation ~~~~~~~~~~~~~~~~~~~~~~~
    if Current_Condition == 1
        ...
    elseif Current_Condition == 2
    ...
    elseif Current_Condition == 3
    ...
    end
    %~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

    %~~~~ Get the answer ~~~~~~~~~~~~~~~~~~~~~
    Onset_time = GetSecs;

    Behavior = round(rand(1));

    %Calculate the reaction time
    Offset_time = GetSecs;
    ReactionTime = Offset_time - Onset_time;
    %~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

    %~1) Put the answer into the matrix
    Data_raw(ii,1) = ii;
    Data_raw(ii,2) = Current_Condition;
    Data_raw(ii,3) = Current_Stimulus;
    Data_raw(ii,4) = Behavior;
    Data_raw(ii,5) = ReactionTime;

    %~2) Put the answer into the stracture
    Data(Current_Condition).AnswerSheet(Current_RowNumber,Current_ColumnNumber) = Behavior;
    Data(Current_Condition).PresentationOrder(Current_RowNumber,Current_ColumnNumber) = ii;


end
%===============End the Experiment=========================================

save(fname,'Data_raw','Data');
ShowCursor;
Screen('CloseAll');
    
catch ME
    ShowCursor;
    Screen('CloseAll');
    rethrow(ME);
end;


%% local function
function [Data,Total_Number_of_Trial,Condition_Number,Row_Number,Column_Number] =...
    ConstantStimuli(Condition,Stimulus,Number_of_Repeart,Name_of_Condition)

Number_of_Condition = length(Condition);
Number_of_Stimulus = length(Stimulus);

%====Make the answer sheet =========
Answer_Sheet = zeros(Number_of_Stimulus,Number_of_Repeart+1)-999;
Answer_Sheet(:,1) = Stimulus;
Presentation = Answer_Sheet;
%===================================

%====Make Data set =================
for i = 1:Number_of_Condition
    Data(i).Condition = Name_of_Condition(i);
    Data(i).AnswerSheet = Answer_Sheet;
    Data(i).PresentationOrder = Presentation;
end
%===================================

Total_Number_of_Trial = Number_of_Condition * Number_of_Stimulus * Number_of_Repeart;
Randam_condition_Number = randperm(Total_Number_of_Trial)-1;

Condition_Number = floor((Randam_condition_Number)/(Number_of_Stimulus*Number_of_Repeart))+1;
TrialNumber_inCondition = mod((Randam_condition_Number),(Number_of_Stimulus*Number_of_Repeart));
Row_Number = floor(TrialNumber_inCondition/Number_of_Repeart)+1;
Column_Number = mod(TrialNumber_inCondition,Number_of_Repeart)+1+1;
