function Presentation
%
%2015/07/13 Hisakata made

AssertOpenGL;

try  
    input('Please press Enter.');
    
    %========Open window and get the window size=======
    screenNumbers=Screen('Screens');                            
    [wp,Screen_rect] = Screen('OpenWindow',max(screenNumbers));
    xcenter = Screen_rect(3)/2;
    ycenter = Screen_rect(4)/2;
    %==================================================
    
    %=========Variables=============
    PresentationDuration = 1;
    Number_of_Presentation = 5;
    Position_of_Stimulus = [0 0]; % [x y]
    %=====================================
    
    %========Prepare the image============
    Stimulus_matrix = imread('sample1.jpg');
    
    [y_matrix, x_matrix, z_matrix] = size(Stimulus_matrix);
    
    Stimulus_texture = Screen('MakeTexture',wp,Stimulus_matrix);
    %====================================

    %=======Calculate the presentation position=================
    Center_rect = [xcenter ycenter xcenter ycenter];
    Position_rect = [Position_of_Stimulus(1) Position_of_Stimulus(2) ...
                     Position_of_Stimulus(1) Position_of_Stimulus(2)];
    Stimulus_rect = [-x_matrix/2, -y_matrix/2, x_matrix/2, y_matrix/2];

    Stimulus_position_rect = Center_rect + Position_rect + Stimulus_rect;
    %===========================================================

    
    %~~~~~~~~~~~~~~~~~Presentation~~~~~~~~~~~~~~~~~~~~~~~
    HideCursor;
    
    for i = 1:Number_of_Presentation
        Screen('FillRect',wp,[127 127 127]);        
        Screen('DrawTexture',wp,Stimulus_texture,[],Stimulus_position_rect);  
        Screen('Flip',wp);                          
        
        WaitSecs(PresentationDuration);             
        
        Screen('FillRect',wp,[127 127 127]);        
        Screen('Flip',wp);                          
        KbWait;                                     
        
        WaitSecs(0.5);                              
    end
    %~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    
    
    %=====Close the window====================
    ShowCursor;
    Screen('CloseAll');
    %=========================================
    
catch ME
    ShowCursor;
    Screen('CloseAll');
    rethrow(ME);
end;