function Presentation3
%
%2015/07/13 Hisakata made

AssertOpenGL;

try
    input('Please press Enter.');
    
    %========Open window and get the window size=======
    screenNumbers=Screen('Screens');
    [wp,Screen_rect] = Screen('OpenWindow',max(screenNumbers));
    xcenter = Screen_rect(3)/2;
    ycenter = Screen_rect(4)/2;
    %==================================================
    
    %====== Variables ======================================
    fixation_size = 10; %pix
    Left_position = [-300 0]; %pix
    Right_position = [300 0]; %pix
    Name_of_Buttom = {'z','m'};
    %=======================================================
    
    %====== Prepare the image ==============================
    Red_matrix = imread('red.jpg');
    Green_matrix = imread('green.jpg');
    [yred_matrix, xred_matrix, zred_matrix] = size(Red_matrix);
    [ygreen_matrix, xgreen_matrix, zgreen_matrix] = size(Green_matrix);
    
    Red_texture = Screen('MakeTexture',wp,Red_matrix);
    Green_texture = Screen('MakeTexture',wp,Green_matrix);
    %=======================================================
    
    %====== Make a stracture================================
    Number_of_Presentation = 5;
    %=======================================================
    
    %=======Calculate the presentation position=================
    center_rect = [xcenter ycenter xcenter ycenter];
    Right_rect = [Right_position(1) Right_position(2) Right_position(1) Right_position(2)];
    Left_rect = [Left_position(1) Left_position(2) Left_position(1) Left_position(2)];
    Red_rect = [ -xred_matrix/2 -yred_matrix/2 xred_matrix/2 yred_matrix/2];
    Green_rect = [ -xgreen_matrix/2 -ygreen_matrix/2 xgreen_matrix/2 ygreen_matrix/2];
    
    Right_red_rect   = center_rect + Right_rect + Red_rect;
    Right_green_rect = center_rect + Right_rect + Green_rect;
    Left_red_rect    = center_rect + Left_rect + Red_rect;
    Left_green_rect  = center_rect + Left_rect + Green_rect;
    Fixation_rect = center_rect + [-fixation_size/2 -fixation_size/2 fixation_size/2 fixation_size/2];
    %===========================================================
    
    
    %==== Begin the Experiment =================================
    HideCursor;
    
    %==== start ============================================
    
    %~~~~ Presentation ~~~~~~~~~~~~~~~~~~
    Screen('FillRect',wp,[0 0 0]);
    Screen('FillArc',wp,[255 255 255],Fixation_rect,0,360);
    Screen('Flip',wp);
    %~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    
    KbWait;
    
    %=======================================================
    
    for i = 1:Number_of_Presentation
        
        Current_Condition = 1;
        Current_trial = i;
        
        %==== Red Right condition (correct = zkey)==============
        if Current_Condition == 1
            
            %~~~~ Presentation ~~~~~~~~~~~~~~
            Screen('FillRect',wp,[0 0 0]);
            Screen('FillArc',wp,[255 255 255],Fixation_rect,0,360);
            Screen('Flip',wp);
            WaitSecs(1);
            
            Screen('FillRect',wp,[0 0 0]);
            Screen('FillArc',wp,[255 255 255],Fixation_rect,0,360);
            Screen('DrawTexture',wp,Red_texture,[],Right_red_rect);
            Screen('Flip',wp);
            %~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            
            %~~~~ Get the answer ~~~~~~~~~~~~
            Onset_time = GetSecs;
            while 1
                [keyIsDown, secs, keyCode] = KbCheck;
                if keyIsDown
                    if strcmp(KbName(keyCode),Name_of_Buttom(1))
                        PrestedButtom = 1
                        Corrent = 1
                        break
                    elseif strcmp(KbName(keyCode),Name_of_Buttom(2))
                        PrestedButtom = 2
                        Corrent = 0
                        break
                    end
                end
            end
            %Calculate the reaction time
            Offset_time = GetSecs;
            ReactionTime = Offset_time - Onset_time;
            %~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            
            %==== Red Left condition (correct = zkey)===============
        elseif Current_Condition == 2
            
            %~~~~ Presentation ~~~~~~~~~~~~~~
            Screen('FillRect',wp,[0 0 0]);
            Screen('FillArc',wp,[255 255 255],Fixation_rect,0,360);
            Screen('Flip',wp);
            WaitSecs(1);
            
            Screen('FillRect',wp,[0 0 0]);
            Screen('FillArc',wp,[255 255 255],Fixation_rect,0,360);
            Screen('DrawTexture',wp,Red_texture,[],Left_red_rect);
            Screen('Flip',wp);
            %~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            
            %~~~~ Get the answer ~~~~~~~~~~~~
            Onset_time = GetSecs;
            while 1
                [keyIsDown, secs, keyCode] = KbCheck;
                if keyIsDown
                    if strcmp(KbName(keyCode),Name_of_Buttom(1))
                        PrestedButtom = 1
                        Corrent = 1
                        break
                    elseif strcmp(KbName(keyCode),Name_of_Buttom(2))
                        PrestedButtom = 2
                        Corrent = 0
                        break
                    end
                end
            end
            %Calculate the reaction time
            Offset_time = GetSecs;
            ReactionTime = Offset_time - Onset_time
            %~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            
            %==== Green Right conditoin (correct = mkey)============
        elseif Current_Condition == 3
            
            %~~~~ Presentation ~~~~~~~~~~~~~~
            Screen('FillRect',wp,[0 0 0]);
            Screen('FillArc',wp,[255 255 255],Fixation_rect,0,360);
            Screen('Flip',wp);
            WaitSecs(1);
            
            Screen('FillRect',wp,[0 0 0]);
            Screen('FillArc',wp,[255 255 255],Fixation_rect,0,360);
            Screen('DrawTexture',wp,Green_texture,[],Right_green_rect);
            Screen('Flip',wp);
            %~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            
            %~~~~ Get the answer ~~~~~~~~~~~~
            Onset_time = GetSecs;
            while 1
                [keyIsDown, secs, keyCode] = KbCheck;
                if keyIsDown
                    if strcmp(KbName(keyCode),Name_of_Buttom(1))
                        PrestedButtom = 1
                        Corrent = 0
                        break
                    elseif strcmp(KbName(keyCode),Name_of_Buttom(2))
                        PrestedButtom = 2
                        Corrent = 1
                        break
                    end
                end
            end
            %Calculate the reaction time
            Offset_time = GetSecs;
            ReactionTime = Offset_time - Onset_time
            %~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            
            %==== Green Left condition (correct = mkey)=============
        elseif Current_Condition == 4
            
            %~~~~ Presentation ~~~~~~~~~~~~~~
            Screen('FillRect',wp,[0 0 0]);
            Screen('FillArc',wp,[255 255 255],Fixation_rect,0,360);
            Screen('Flip',wp);
            WaitSecs(1);
            
            Screen('FillRect',wp,[0 0 0]);
            Screen('FillArc',wp,[255 255 255],Fixation_rect,0,360);
            Screen('DrawTexture',wp,Green_texture,[],Left_green_rect);
            Screen('Flip',wp);
            %~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            
            %~~~~ Get the answer ~~~~~~~~~~~~
            Onset_time = GetSecs;
            while 1
                [keyIsDown, secs, keyCode] = KbCheck;
                if keyIsDown
                    if strcmp(KbName(keyCode),Name_of_Buttom(1))
                        PrestedButtom = 1
                        Corrent = 0
                        break
                    elseif strcmp(KbName(keyCode),Name_of_Buttom(2))
                        PrestedButtom = 2
                        Corrent = 1
                        break
                    end
                end
            end
            %Calculate the reaction time
            Offset_time = GetSecs;
            ReactionTime = Offset_time - Onset_time
            %~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            
        end
        
        Screen('FillRect',wp,[0 0 0]);
        Screen('Flip',wp);
        WaitSecs(0.5);    end
    %~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    
    
    %=====Close the window====================
    ShowCursor;
    Screen('CloseAll');
    %=========================================
    
catch ME
    ShowCursor;
    Screen('CloseAll');
    rethrow(ME);
end;