function Simon_Effect
%
%2015/07/21 Hisakata made

AssertOpenGL;

try
    %====== Make file name =================================
    subject = input('Subject Name?','s');
    block = 1;
    while 1
        fname = sprintf('%s_SimonTask_%d',subject,block);
        
        A = exist([fname '.mat']);
        B = exist([fname '.txt']);
        if (A == 0) || (B==0);
            break;
        else
            block = block+1;
        end
    end
    disp(fname);
    WaitSecs(0.2);
    fnameOK = input('File name, OK? y:yes, n:no....','s');
    switch fnameOK
        case 'y'
        case 'n'
            return
    end
    %=======================================================
    
    %====== Open window and get the window size ============
    screenNumbers=Screen('Screens');
    [wp,Screen_rect] = Screen('OpenWindow',max(screenNumbers));
    xcenter = Screen_rect(3)/2;
    ycenter = Screen_rect(4)/2;
    %=======================================================

    %====== Variables ======================================
    fixation_size = 10; %pix
    Left_position = [-300 0]; %pix
    Right_position = [300 0]; %pix
    Name_of_Buttom = {'z','m'};
    %=======================================================
    
    %====== Prepare the image ==============================
    Red_matrix = imread('red.jpg');
    Green_matrix = imread('green.jpg');
    [yred_matrix, xred_matrix, zred_matrix] = size(Red_matrix);
    [ygreen_matrix, xgreen_matrix, zgreen_matrix] = size(Green_matrix);
    
    Red_texture = Screen('MakeTexture',wp,Red_matrix);
    Green_texture = Screen('MakeTexture',wp,Green_matrix);
    %=======================================================

    %====== Make a stracture================================
    Condition = [1 2 3 4];                            
    Name_of_Condition = {'Red_Right','Red_Left','Green_Right','Green_Left'};    
    Number_of_Condition = length(Condition);
    Number_of_Repeart = 10;
        
    [Data,Randam_Order_Condition,Randam_Order_trial,Total_Number_of_Trial] = MakeDataFile_ReactionTime(Number_of_Repeart,Number_of_Condition,Name_of_Condition);
    
    Data_raw = zeros(Total_Number_of_Trial,4)-999;
    %=======================================================

    %==== Calculate the presentation position===============
    center_rect = [xcenter ycenter xcenter ycenter];
    Right_rect = [Right_position(1) Right_position(2) Right_position(1) Right_position(2)];
    Left_rect = [Left_position(1) Left_position(2) Left_position(1) Left_position(2)];
    Red_rect = [ -xred_matrix/2 -yred_matrix/2 xred_matrix/2 yred_matrix/2];
    Green_rect = [ -xgreen_matrix/2 -ygreen_matrix/2 xgreen_matrix/2 ygreen_matrix/2];
    
    Right_red_rect   = center_rect + Right_rect + Red_rect;
    Right_green_rect = center_rect + Right_rect + Green_rect;
    Left_red_rect    = center_rect + Left_rect + Red_rect;
    Left_green_rect  = center_rect + Left_rect + Green_rect;
    Fixation_rect = center_rect + [-fixation_size/2 -fixation_size/2 fixation_size/2 fixation_size/2];
    %=======================================================
    

%==== Begin the Experiment =================================
HideCursor;

%==== start ============================================

%~~~~ Presentation ~~~~~~~~~~~~~~~~~~
Screen('FillRect',wp,[0 0 0]);
Screen('FillArc',wp,[255 255 255],Fixation_rect,0,360);
Screen('Flip',wp);
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

KbWait;     

%=======================================================

for ii = 1:Total_Number_of_Trial
    
    Current_Condition = Randam_Order_Condition(ii);
    Current_trial = Randam_Order_trial(ii);
    

    
    %==== Red Right condition (correct = zkey)==============
    if Current_Condition == 1 
        
        %~~~~ Presentation ~~~~~~~~~~~~~~
        Screen('FillRect',wp,[0 0 0]);
        Screen('FillArc',wp,[255 255 255],Fixation_rect,0,360);
        Screen('Flip',wp);
        WaitSecs(1);
        
        Screen('FillRect',wp,[0 0 0]);
        Screen('FillArc',wp,[255 255 255],Fixation_rect,0,360);
        Screen('DrawTexture',wp,Red_texture,[],Right_red_rect);
        Screen('Flip',wp);
        %~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        
        %~~~~ Get the answer ~~~~~~~~~~~~
        Onset_time = GetSecs;
        while 1
            [keyIsDown, secs, keyCode] = KbCheck;
            if keyIsDown
                if strcmp(KbName(keyCode),Name_of_Buttom(1))
                    PrestedButtom = 1;
                    Corrent = 1;
                    break
                elseif strcmp(KbName(keyCode),Name_of_Buttom(2))
                    PrestedButtom = 2;
                    Corrent = 0;
                    break
                end
            end
        end
        %Calculate the reaction time
        Offset_time = GetSecs;
        ReactionTime = Offset_time - Onset_time;
        %~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
     
    %==== Red Left condition (correct = zkey)===============
    elseif Current_Condition == 2 
        
        %~~~~ Presentation ~~~~~~~~~~~~~~
        Screen('FillRect',wp,[0 0 0]);
        Screen('FillArc',wp,[255 255 255],Fixation_rect,0,360);
        Screen('Flip',wp);
        WaitSecs(1);
        
        Screen('FillRect',wp,[0 0 0]);
        Screen('FillArc',wp,[255 255 255],Fixation_rect,0,360);
        Screen('DrawTexture',wp,Red_texture,[],Left_red_rect);
        Screen('Flip',wp);
        %~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        
        %~~~~ Get the answer ~~~~~~~~~~~~
        Onset_time = GetSecs;
        while 1
            [keyIsDown, secs, keyCode] = KbCheck;
            if keyIsDown
                if strcmp(KbName(keyCode),Name_of_Buttom(1))
                    PrestedButtom = 1;
                    Corrent = 1;
                    break
                elseif strcmp(KbName(keyCode),Name_of_Buttom(2))
                    PrestedButtom = 2;
                    Corrent = 0;
                    break
                end
            end
        end
        %Calculate the reaction time
        Offset_time = GetSecs;
        ReactionTime = Offset_time - Onset_time;
        %~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    
    %==== Green Right conditoin (correct = mkey)============
    elseif Current_Condition == 3
        
        %~~~~ Presentation ~~~~~~~~~~~~~~
        Screen('FillRect',wp,[0 0 0]);
        Screen('FillArc',wp,[255 255 255],Fixation_rect,0,360);
        Screen('Flip',wp);
        WaitSecs(1);
        
        Screen('FillRect',wp,[0 0 0]);
        Screen('FillArc',wp,[255 255 255],Fixation_rect,0,360);
        Screen('DrawTexture',wp,Green_texture,[],Right_green_rect);
        Screen('Flip',wp);
        %~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        
        %~~~~ Get the answer ~~~~~~~~~~~~
        Onset_time = GetSecs;
        while 1
            [keyIsDown, secs, keyCode] = KbCheck;
            if keyIsDown
                if strcmp(KbName(keyCode),Name_of_Buttom(1))
                    PrestedButtom = 1;
                    Corrent = 0;
                    break
                elseif strcmp(KbName(keyCode),Name_of_Buttom(2))
                    PrestedButtom = 2;
                    Corrent = 1;
                    break
                end
            end
        end
        %Calculate the reaction time
        Offset_time = GetSecs;
        ReactionTime = Offset_time - Onset_time;
        %~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      
    %==== Green Left condition (correct = mkey)=============
    elseif Current_Condition == 4
        
        %~~~~ Presentation ~~~~~~~~~~~~~~
        Screen('FillRect',wp,[0 0 0]);
        Screen('FillArc',wp,[255 255 255],Fixation_rect,0,360);
        Screen('Flip',wp);
        WaitSecs(1);
        
        Screen('FillRect',wp,[0 0 0]);
        Screen('FillArc',wp,[255 255 255],Fixation_rect,0,360);
        Screen('DrawTexture',wp,Green_texture,[],Left_green_rect);
        Screen('Flip',wp);
        %~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        
        %~~~~ Get the answer ~~~~~~~~~~~~
        Onset_time = GetSecs;
        while 1
            [keyIsDown, secs, keyCode] = KbCheck;
            if keyIsDown
                if strcmp(KbName(keyCode),Name_of_Buttom(1))
                    PrestedButtom = 1;
                    Corrent = 0;
                    break
                elseif strcmp(KbName(keyCode),Name_of_Buttom(2))
                    PrestedButtom = 2;
                    Corrent = 1;
                    break
                end
            end
        end
        %Calculate the reaction time
        Offset_time = GetSecs;
        ReactionTime = Offset_time - Onset_time;
        %~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        
    end
    
    Screen('FillRect',wp,[0 0 0]);
    Screen('Flip',wp);
    WaitSecs(0.5);
    
    %~1) Put the answer into the matrix
    Data_raw(ii,1) = ii;
    Data_raw(ii,2) = Current_Condition;
    Data_raw(ii,3) = PrestedButtom;
    Data_raw(ii,4) = ReactionTime * 1000;
    Data_raw(ii,5) = Corrent;
    
    %~2) Put the answer into the stracture
    Data(Current_Condition).AnswerSheet(Current_trial) = PrestedButtom;
    Data(Current_Condition).ReactionTime(Current_trial) = ReactionTime * 1000;
    Data(Current_Condition).CorrectSheet(Current_trial) = Corrent;
    Data(Current_Condition).PresentationNumber(Current_trial) = ii;

end
%===============End the Experiment===================

%====== Make mat file ===============================
save([fname '.mat'],'Data_raw','Data');

%====== Make text file ===============================
fid = fopen([fname '.txt'], 'at');
fprintf(fid, 'trial condition PrestedButtom ReactionTime Correct\n');

for trial = 1:max(Data_raw(:,1))
    fprintf(fid, '%d %s %s %4.0f %d \n', Data_raw(trial,1), Name_of_Condition{Data_raw(trial,2)}, Name_of_Buttom{Data_raw(trial,3)}, Data_raw(trial,4), Data_raw(trial,5));
end
fprintf(fid, 'subject %s\n', subject);
fprintf(fid, '%s\n',datestr(now,0));
fclose(fid);

ShowCursor;
Screen('CloseAll');

catch ME
    ShowCursor;
    Screen('CloseAll');
    rethrow(ME);
end

%% local function
function [Data,Randam_Order_Condition,Randam_Order_trial,Total_Number_of_Trial] = MakeDataFile_ReactionTime(Number_of_Repeart,Number_of_Condition,Name_of_Condition);
Answer_Sheet = zeros(1,Number_of_Repeart)-999;
Reaction_Time = zeros(1,Number_of_Repeart)-999;
Correct_Sheet = zeros(1,Number_of_Repeart)-999;
Presentation_Number = zeros(1,Number_of_Repeart)-999;

for i = 1:Number_of_Condition
    Data(i).Condition = Name_of_Condition(i);   
    Data(i).AnswerSheet = Answer_Sheet;         
    Data(i).ReactionTime = Reaction_Time;
    Data(i).CorrectSheet = Correct_Sheet;
    Data(i).PresentationNumber = Presentation_Number;
end

Total_Number_of_Trial = Number_of_Condition*Number_of_Repeart;

Randam_condition_Number = randperm(Total_Number_of_Trial);

Randam_Order_Condition = floor((Randam_condition_Number-1)/Number_of_Repeart)+1;
Randam_Order_trial = mod((Randam_condition_Number-1),Number_of_Repeart)+1;
