function SimpleMovie_Demo
%
%2015/09/22 Hisakata made

AssertOpenGL;

try 
    input('Please press Enter');
    
    %========Open window and get the window size=======
    screenNumbers=Screen('Screens');
    [wp,Screen_rect] = Screen('OpenWindow',max(screenNumbers));
    xcenter = Screen_rect(3)/2;
    ycenter = Screen_rect(4)/2;
    %==================================================
    
    %=========Variables===================
    Number_of_Presentation = 1;
    Position_of_Stimulus = [0 0]; % [x y]
    %=====================================
    
    %========Prepare the image============
    NumberOfMovieFrames = 16;
    Stimulus_texture = zeros(1,NumberOfMovieFrames);
    for i = 1:NumberOfMovieFrames
        imagefilename = sprintf('%d.png',i);
        
        Stimulus_matrix = imread(imagefilename);
                
        Stimulus_texture(i) = Screen('MakeTexture',wp,Stimulus_matrix);
    end
    
    HightPixels_texture = size(Stimulus_matrix,1);
    WidthPixels_texture = size(Stimulus_matrix,2);
    %====================================

    %=======Calculate the presentation position===========
    stimulus_xcenter = xcenter + Position_of_Stimulus(1);
    stimulus_ycenter = ycenter + Position_of_Stimulus(2);
    stimulus_center_rect = [stimulus_xcenter stimulus_ycenter stimulus_xcenter stimulus_ycenter];
    stimulus_rect = [0 0 WidthPixels_texture HightPixels_texture];
    
    stimulus_position_rect = stimulus_center_rect+...
        [-WidthPixels_texture/2 -HightPixels_texture/2 WidthPixels_texture/2 HightPixels_texture/2];
    %=====================================================

    RealPresentationTime = zeros(1,Number_of_Presentation) -999;
    
    %~~~~~~~~~~~~~~~~~Presentation~~~~~~~~~~~~~~~~~~~~~~~
    HideCursor;
    
    for ii = 1:Number_of_Presentation    
        Screen('FillRect',wp,[0 0 0]);  
        
        Onset_time = GetSecs;
        for i = 1:NumberOfMovieFrames
            Screen('DrawTexture',wp,Stimulus_texture(i),stimulus_rect,stimulus_position_rect);
            Screen('Flip',wp);
            Screen('WaitBlanking',wp);
        end
        %Calculate the presentation time
        Offset_time = GetSecs;
        RealPresentationTime(ii) = Offset_time - Onset_time;
        
        WaitSecs(1);             
        
        Screen('FillRect',wp,[0 0 0]);        
        Screen('Flip',wp);                          
                                    
    end
    %~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    
    %=====Close the window====================
    ShowCursor;
    Screen('CloseAll');
    %=========================================

    disp(RealPresentationTime);
    
catch ME
    ShowCursor;
    Screen('CloseAll');
    rethrow(ME);
end;
