function Simple_UpDown_method
%
%2015/07/06 Hisakata made

AssertOpenGL;

try
    fname = sprintf('Experiment.mat');
    
    %=======Make a stracture========
    Condition = [1 2 3];                            
    Name_of_Condition = {'Cond1' 'Cond2' 'Cond3'};
    Number_of_Condition = length(Condition);
    
    Min_stimulus = -50;                              
    Max_stimulus = 50;                               
    Start_stimulus = 0;                             
    StepSize = 1;                                   
    TotalRunNumber = 6;                             
    
    
    for i = 1:Number_of_Condition
        Data(i).Condition = Name_of_Condition(i);  
        Data(i).Answer = -999;                      
        Data(i).Stimulus = Start_stimulus;          
        Data(i).NextStimulus = Start_stimulus;      
        Data(i).RunNumber = 0;                      
        Data(i).TrialNumber = 0;                    
    end
    %================================
    
    
%========= Begin the Experiment ===========================================
HideCursor;
while 1

    RandamTrialNumber_inCondition = 5;
    RandamTrials = RandamTrialNumber_inCondition * Number_of_Condition;
    TrialOrder = randperm(RandamTrials);
    ConditionOrder = floor((TrialOrder-1)/RandamTrialNumber_inCondition)+1;

    for ii = 1:RandamTrials
        Current_Condition = ConditionOrder(ii);

        Current_TrialNumber = Data(Current_Condition).TrialNumber+1;
        Current_Stimulus = Data(Current_Condition).NextStimulus;

        if Data(Current_Condition).RunNumber == TotalRunNumber
            ;
        else

            %~~~~ Presentation ~~~~~~~~~~~~~~~~~~
            if Current_Condition == 1
                ...
            elseif Current_Condition == 2
            ...
            elseif Current_Condition == 3
            ...
            end
            %~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

            %~~~~ Get the answer ~~~~~~~~~~~~~~~~~~~~~
            Behavior = round(rand(1));
            %~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


            [Next_Stimulus,RunNumber] = OneUp_OneDown(Data,Current_Condition,...
                Current_TrialNumber,Current_Stimulus,Behavior,StepSize,Min_stimulus,Max_stimulus);

            Data(Current_Condition).Answer(Current_TrialNumber) = Behavior;
            Data(Current_Condition).Stimulus(Current_TrialNumber) = Current_Stimulus;
            Data(Current_Condition).NextStimulus = Next_Stimulus;
            Data(Current_Condition).RunNumber = RunNumber;
            Data(Current_Condition).TrialNumber = Current_TrialNumber;
        end
    end

    RunNumber_for_Ending = TotalRunNumber*Number_of_Condition;
    Corrent_TotalRunNumber = 0;
    for iii = 1:Number_of_Condition
        Corrent_TotalRunNumber = Corrent_TotalRunNumber + Data(iii).RunNumber;
    end
    if Corrent_TotalRunNumber == RunNumber_for_Ending
        break
    end
end
%===============End the Experiment=========================================
    
save(fname,'Data');
ShowCursor;
Screen('CloseAll');

catch ME
    ShowCursor;
    Screen('CloseAll');
    rethrow(ME);
end;

%% local function
function [Next_Stimulus,RunNumber] = OneUp_OneDown(Data,Current_Condition,...
    Current_TrialNumber,Current_Stimulus,Behavior,StepSize,Min_stimulus,Max_stimulus)

if Behavior == 0
    Next_Stimulus = Current_Stimulus+StepSize;
    if Next_Stimulus > Max_stimulus
        Next_Stimulus = Max_stimulus;
    end
elseif Behavior == 1
    Next_Stimulus = Current_Stimulus-StepSize;
    if Next_Stimulus < Min_stimulus
        Next_Stimulus = Min_stimulus;
    end
end

if Current_TrialNumber == 1
    RunNumber = 0;
else
    PreviousBehavior = Data(Current_Condition).Answer(Current_TrialNumber-1);
    if Behavior == PreviousBehavior
        RunNumber = Data(Current_Condition).RunNumber;
    else
        RunNumber = Data(Current_Condition).RunNumber + 1;
    end
end