function Simple_UpDown_method_single
%
%2015/07/06 Hisakata made

AssertOpenGL;

try
    fname = sprintf('Experiment.mat');
    
    %=======Make a structure========
                            
    Name_of_Condition = 'Cond1';
    
    Min_stimulus = -50;                              
    Max_stimulus = 50;                               
    Start_stimulus = 0;                             
    StepSize = 1;                                   
    TotalRunNumber = 6;
    
    
    Data.Condition = Name_of_Condition;  
    Data.Answer = -999;                      
    Data.Stimulus = Start_stimulus;          
    Data.NextStimulus = Start_stimulus;      
    Data.RunNumber = 0;                      
    Data.TrialNumber = 0;                    
    
    %================================
    
    
%========= Begin the Experiment ===========================================
HideCursor;
while 1

    Current_TrialNumber = Data.TrialNumber+1;
    Current_Stimulus = Data.NextStimulus;

    if Data.RunNumber >= TotalRunNumber
        break;
    else
        %~~~~ Presentation ~~~~~~~~~~~~~~~~~~

        %~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

        %~~~~ Get the answer ~~~~~~~~~~~~~~~~~~~~~
        Behavior = round(rand(1));
        %~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


        [Next_Stimulus,RunNumber] = OneUp_OneDown(Data,...
            Current_TrialNumber,Current_Stimulus,Behavior,StepSize,Min_stimulus,Max_stimulus);

        Data.Answer(Current_TrialNumber) = Behavior;
        Data.Stimulus(Current_TrialNumber) = Current_Stimulus;
        Data.NextStimulus = Next_Stimulus;
        Data.RunNumber = RunNumber;
        Data.TrialNumber = Current_TrialNumber;
    end

end
%===============End the Experiment=========================================
    
save(fname,'Data');
ShowCursor;
Screen('CloseAll');

catch ME
    ShowCursor;
    Screen('CloseAll');
    rethrow(ME);
end;

%% local function
function [Next_Stimulus,RunNumber] = OneUp_OneDown(Data,...
    Current_TrialNumber,Current_Stimulus,Behavior,StepSize,Min_stimulus,Max_stimulus)

if Behavior == 0
    Next_Stimulus = Current_Stimulus+StepSize;
    if Next_Stimulus > Max_stimulus
        Next_Stimulus = Max_stimulus;
    end
elseif Behavior == 1
    Next_Stimulus = Current_Stimulus-StepSize;
    if Next_Stimulus < Min_stimulus
        Next_Stimulus = Min_stimulus;
    end
end

if Current_TrialNumber == 1
    RunNumber = 0;
else
    PreviousBehavior = Data.Answer(Current_TrialNumber-1);
    if Behavior == PreviousBehavior
        RunNumber = Data.RunNumber;
    else
        RunNumber = Data.RunNumber + 1;
    end
end